# MPI_Type_set_attr

## NAME

MPI_Type_set_attr − Sets a key value/attribute pair to a data type.

## SYNTAX

## C Syntax

#include <mpi.h>
int MPI_Type_set_attr(MPI_Datatype type, int type_keyval,

|  | void *attribute_val)

## Fortran Syntax (see FORTRAN 77 NOTES)

INCLUDE ’mpif.h’
MPI_TYPE_SET_ATTR(TYPE, TYPE_KEYVAL, ATTRIBUTE_VAL, IERROR)

| INTEGER |  |  | TYPE, TYPE_KEYVAL, IERROR
| INTEGER(KIND=MPI_ADDRESS_KIND) ATTRIBUTE_VAL |  |  |

## C++ Syntax

#include <mpi.h>
void MPI::Datatype::Set_attr(int type_keyval, const void* attribute_val)

## INPUT/OUTPUT PARAMETER

| type |  | Data type to which attribute will be attached (handle).

## INPUT PARAMETERS

type_keyval

Key value (integer).

attribute_val

Attribute value.

## OUTPUT PARAMETER

| IERROR |  | Fortran only: Error status (integer). |

## DESCRIPTION

For the given data type, MPI_Type_set_attr sets the key value to the value of the specified attribute.

## FORTRAN 77 NOTES

The MPI standard prescribes portable Fortran syntax for the ATTRIBUTE_VAL argument only for Fortran 90. FORTRAN 77 users may use the non-portable syntax

INTEGER*MPI_ADDRESS_KIND ATTRIBUTE_VAL

where MPI_ADDRESS_KIND is a constant defined in mpif.h and gives the length of the declared integer in bytes.

## ERRORS

Almost all MPI routines return an error value; C routines as the value of the function and Fortran routines in the last argument. C++ functions do not return errors. If the default error handler is set to MPI::ERRORS_THROW_EXCEPTIONS, then on error the C++ exception mechanism will be used to throw an MPI:Exception object.

Before the error value is returned, the current MPI error handler is called. By default, this error handler aborts the MPI job, except for I/O function errors. The error handler may be changed with MPI_Comm_set_errhandler; the predefined error handler MPI_ERRORS_RETURN may be used to cause error values to be returned. Note that MPI does not guarantee that an MPI program can continue past an error.

## SEE ALSO

MPI_Type_get_attr

MPI API Index